package com.gic.spark.filter;

import com.gic.spark.datasource.entity.DataSourceHive;
import com.gic.spark.entity.bean.TrdEcuBrandLabelBean;
import com.gic.spark.entity.bean.TrdEcuSalesLabelBean;
import com.gic.spark.entity.request.AbstractFilterRequest;
import com.gic.spark.entity.request.TagConsumeRequest;
import com.gic.spark.util.ConstantUtil;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.Optional;
import scala.Tuple2;

import java.util.ArrayList;
import java.util.List;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/5/7
 */
public abstract class AbstractTagConsumFilter implements BaseTagFilter {
    DataSourceHive dataSourceHiveBrandLabel = new DataSourceHive(ConstantUtil.ADS_GIC_TRD_ECU_BRAND_LABEL_D);
    DataSourceHive dataSourceHiveSalesLabel = new DataSourceHive(ConstantUtil.ADS_GIC_TRD_ECU_SALES_LABEL_D);

    protected static JavaRDD<TrdEcuSalesLabelBean> statisticsTypeHandle(JavaRDD<Tuple2<TrdEcuSalesLabelBean,Optional<Iterable<TrdEcuBrandLabelBean>>>>labelRDD, AbstractFilterRequest consumeRequest){
        JavaRDD<TrdEcuSalesLabelBean> consumeRDD=labelRDD.mapPartitions(data->{
                                    List<TrdEcuSalesLabelBean> result=new ArrayList();
                                    while (data.hasNext()){
                                        Tuple2<TrdEcuSalesLabelBean,Optional<Iterable<TrdEcuBrandLabelBean>>> tp2=data.next();
                                        TrdEcuSalesLabelBean consumeBean=tp2._1();
                                        switch (consumeRequest.getStatisticsType()){
                                            case COMMODITYBRAND:
                                                if(tp2._2().isPresent()){
                                                    for(TrdEcuBrandLabelBean brandLabelBean:tp2._2().get()){
                                                        if(consumeRequest.getStatisticsValList().contains(String.valueOf(brandLabelBean.getEnt_brand_id()))){
                                                            result.add(brandLabelToSalesLabel(brandLabelBean));
                                                        }
                                                    }
                                                }
                                                break;
                                            case CHANNEL:
                                                if(consumeRequest.getStatisticsValList().contains(String.valueOf(consumeBean.getStore_info_id()))){
                                                    result.add(consumeBean);
                                                }
                                                break;
                                            case MCUINFO:
                                                if(consumeRequest.getStatisticsValList().contains(String.valueOf(consumeBean.getMbr_area_id()))){
                                                    result.add(consumeBean);
                                                }
                                                break;
                                            default:break;
                                        }
                                    }
                                    return result.iterator();
                                });
        return consumeRDD;
    }

    protected static TrdEcuSalesLabelBean brandLabelToSalesLabel(TrdEcuBrandLabelBean brandLabelBean){
        TrdEcuSalesLabelBean salesLabelBean=new TrdEcuSalesLabelBean();
        salesLabelBean.setEnt_id(brandLabelBean.getEnt_id());
        salesLabelBean.setMbr_area_id(brandLabelBean.getMbr_area_id());
        salesLabelBean.setEcu_id(brandLabelBean.getEcu_id());
        salesLabelBean.setStore_info_id(brandLabelBean.getStore_info_id());
        salesLabelBean.setOrder_times(brandLabelBean.getOrder_times());
        salesLabelBean.setSeff_goods_num(brandLabelBean.getSeff_goods_num());
        salesLabelBean.setSeff_order_cnt(brandLabelBean.getSeff_order_cnt());
        salesLabelBean.setReceive_amt(brandLabelBean.getReceive_amt());
        salesLabelBean.setPay_amt(brandLabelBean.getPay_amt());
        salesLabelBean.setTotal_amt(brandLabelBean.getTotal_amt());
        salesLabelBean.setSleep_days(brandLabelBean.getSleep_days());

        return salesLabelBean;
    }
}
